/*
 *  Test that we can open a device name.
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <sys/mman.h>

main(argc, argv)
	int		argc;
	char	*argv[];
{
	int	fd;	/* File descriptor for device opened. */
	int	value;
	int	k;
	int	length;
	int	offset;
	int	page_cnt;
	u_int	*msk;
	caddr_t addr;
	caddr_t m8addr;
	caddr_t m24addr;
	u_int	*tmr;
	u_int   *clr;

	if ( argc != 2 )
	{
		fprintf(stderr, "Usage: open device\n");
	}

	fd = open(argv[1], O_RDWR);

	if ( fd == -1 )
	{
		fprintf(stdout, "Unable to open %s\n", argv[1]);
	}
	else
	{
		fprintf(stdout, "Opened %s with file descriptor %d\n", argv[1], fd);
		addr= mmap((caddr_t)0,0x2000,PROT_READ|PROT_WRITE,MAP_SHARED,
			fd,0x800000);

		printf("mmaped addr=0x%x\n",addr); 

/*
		tmr= (u_int *)(addr+0x210);
		*tmr= 4096;
		tmr= (u_int *)(addr+8);
		value= *tmr;
		printf("value=%d\n",value);
 */
		clr= (u_int *)(addr+0x408);
		value= *clr;
		printf("IntstatC=0x%x\n",value);
		value= *clr;
		printf("IntstatC=0x%x\n",value);
		msk= (u_int *)(addr+0xa8);
		*msk= 0x8001;
		clr= (u_int *)(addr+0x408);
		value= *clr;
		printf("IntstatC=0x%x\n",value);
#ifdef XVREG_TEST
		length= 0x100000;
		printf("length=0x%x\n",length);
		offset=0x40000;
	m8addr= (caddr_t)mmap((caddr_t)0,length,PROT_READ|PROT_WRITE,MAP_SHARED,
		fd,offset);
		length= 1024*1024*4;
		offset= 0x140000;
		m24addr= (caddr_t)mmap((caddr_t)0,length,
		    PROT_READ|PROT_WRITE,MAP_SHARED, fd,offset);
		printf("length=0x%x\n",length);
#endif
	}
}
