static int
tvtwo_pfn(tvtwo_softc *softc, XV_regmap *rm, off_t off)
{
	caddr_t addr;
	u_int pfn;

	/*
	 * We need to adjust our passed in offset from the base of
	 * the "virtual" register window and add in our offset from
	 * the base of the real register.
	 */
	off = (off - rm->voff) + rm->offset;

	if (ddi_map_regs(softc->devi, rm->regnum,
		&addr, off, sizeof(int)) != DDI_FAILURE) {

		pfn = hat_getkpfnum(addr);

		ddi_unmap_regs(softc->devi, rm->regnum,
			&addr, off, sizeof(int));
	}

	return (pfn);
}
