#include <stdio.h>
#include <fcntl.h>

#include <sys/framebuf.h>
#include "qtab.h"
#include "c3.h"
#include "xvideo.h"
#include "plxv_xpoint.h"
#include "plxv.h"
/*
#include "rtv_ctl.h"
*/

int fd1,fd2;

unsigned char *dmabuf1;
#define DMABUFSIZ 0x40000

#ifndef SVR4
#define SVR4
#endif

#define TIMEOUT 90000

unsigned char
*MakeQ(factor, buf)
unsigned int factor;
char *buf;
{
	register unsigned char *obuf, *ibuf;
	unsigned char *rbuf;
	register int i, temp;
	int j;

	rbuf = obuf = (unsigned char *) malloc(sizeof(DQTmarker));
	ibuf = (unsigned char *) &DQTmarker;

/* move the first four chars */

	*obuf++ = *ibuf++;
	*obuf++ = *ibuf++;
	*obuf++ = *ibuf++;
	*obuf++ = *ibuf++;

	for(j = 2; j--;)
	{ 
	    *obuf++ = *ibuf++;	/* move one then scale the rest */
	    for(i = 64; i--;)
	    {
		temp = (((unsigned int) *ibuf++) * factor) / 50;
		*obuf++ = (temp < 256) ? temp : 255;
	    }
	}
	return rbuf;
}

#define BWAIT(n) { register int N = (n); while (--N > 0); }
main(argc,argv)
int argc;
char *argv[];
{
	int i,j,k, factor;
	int count1,count2,count;
	char s[10];
	unsigned short *CL550Qtable;
	unsigned short *CL550DQtable;
	unsigned short *CL550Htable;
	unsigned short *CL550DHtable;
	unsigned char *dqtptr;
	unsigned char *hqtptr;
	int dqtsize;
	int hqtsize;
	int timer1,timer2;
	static char defaultdev[12] = "/dev/plxv1";
	char *device = defaultdev;
	int *bptr;
	int *b2ptr;
	char *cbuf;
	int nwords=16;
	int offset = 256;
	int black = 3;
	int rcount;
	int loop=2;
	int dump=0;
	int stop=0;
	int first_time=1;
	u_int first_word;
	int rtv_flags;
	int flip=0;
	int outflip=0;
	int stat;
	u_int last_word;
	char junk[132];
	XV_struct* p_me;

	printf("dma buffer size = %d\n", DMABUFSIZ);

	dmabuf1= (u_char *)malloc(DMABUFSIZ);
	factor = 50;

	for(i = 1; i < argc; ++i)
	{
	    if(*argv[i] == '-')
	    {
		if(*(argv[i]+1) == 'q')
		    sscanf(argv[++i], "%d", &factor);
		else
		    if(*(argv[i]+1) == 'f')
			device= argv[++i];
		else
		    if(*(argv[i]+1) == 't')
			loop= atoi(argv[++i]);
		else
		    if(*(argv[i]+1) == 'd')
			dump= atoi(argv[++i]);
		else
		    if(*(argv[i]+1) == 's')
			stop= atoi(argv[++i]);
		else
		    if(*(argv[i]+1) == 'o')
			offset= atoi(argv[++i]);
		else
		    if(*(argv[i]+1) == 'b')
			black= atoi(argv[++i]);
		else
		    goto use;
	    }
	    else
	    {
use:		printf("usage: %s, [-q #]\n", argv[0]);
		exit(1);
	    }
	}

       /*
        * Initialize
        */

	p_me=pv700_open("/dev/plxv0");

/*
        rtv_flags= (RTVC_SYNC|(5<<RTVC_WAIT_SHIFT));
        stat=ioctl(fd1,RTV_CNTRL,&rtv_flags);
*/


        plxv_tag(p_me, 0xf,0x1);



    plxv_tag(p_me, PLXV_TAG_PIXEL_ATTR,PLXV_TAG_TRUE_COLOR);	
        plxv_video_v_stencil(p_me, 0,0);
        plxv_stencil(p_me, 0,0);
        plxv_video_w_stencil(p_me, 0,0);
        plxv_video_w_wmask(p_me, ~0);
        plxv_video_v_wmask(p_me, ~0);
        plxv_wmask(p_me, ~0);
        plxv_color_24(p_me, 0x0);
	plxv_box(p_me, 0,0,0xfff,1024);
	plxv_box(p_me, 0,0,1280,1024);
	switch (black) {
	case 0:
	case 1:
	    break;
	case 2:
	    plxv_color_24(p_me, 0xffffff);
	    plxv_box(p_me, 600,600,100,100);
	    break;
	case 3:
	    {
		int i;
		int *ip;



#define MM(p_me, x) PV_WREG(p_me, MiscMode.b.red,x);
/*
	MM(p_me, 0);
	MM(p_me, 1);
	*/
		for (i=stop; i<offset; i++) {
		    plxv_color_24(p_me, (i)*0x10101);
		    plxv_box(p_me, 500+i*2,500,2,400);
		}
/*
	MM(p_me, 0);
*/
		ip = PLXV_ADDR_24(500+stop*2,500);
		for (i=stop; i<offset; i++) {
			int j=*ip++;
			*ip++;
			if ((j&0xff)!=i) {
				printf("j(%x) != i(%x)\n",j&0xff,i);
			}
		}
	    }
	    break;
	}
}

