#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>

#include "qtab.h"
#include "c3.h"
#include "objects_pv700.h"
#include "plxv_xpoint.h"
#include "plxv.h"


#define DMABUFSIZ 0x20000

#define TIMEOUT 90000

#define VIDEO

#define BWAIT(n) { register int N = (n); while (--N > 0); }

/*
 *  FORWARD FUNCTION REFERENCES:
 */
int  	analyze();
void 	buf_dump();
void 	Flash();
u_char* MakeQ();
void 	pause();
void	still_image();
static  int c3_src_x = 5;
static  int c3_src_y = 5;

main(argc,argv)
	int   argc;
	char* argv[];
{

	u_short*        CL550DQtable;
	u_short*        CL550Htable;
	u_short*        CL550Qtable;
	int             count;
	char*           device = "/dev/plxv0";
	int             diag=0;
	int             disable = 0;
	int             extra_lines = 0;
	u_char*         dmabuf1;
	int             dump=0;
	int             factor;
	int             fd2;
	int             flip=0;
	int             i;
	int             i_loop;
	int				i_try;
	int				image_no = 0;		/* Still image to use. */
	int             j;
	int             k;
	u_int           last_word;
	int             n_dqt;
	int             n_loops=1;
	int             n_words=32;
	int             offset = 1;
    int             outflip=0; 
	int             output=1;
	int*            p_buf;
	u_char*         p_dqt;
	XV_struct*      p_xv;
	int             rc;
	int				stat_n_bad_gets = 0;
	int				stat_n_bad_puts = 0;
	int				stat_n_dbl_bad_puts = 0;
	int             stat_n_short_recs = 0;
	int				timeout = 0;
	int             timer_micros=0;
	int             timer_seconds=0;
	struct timeval  to;         /* Timer value for wait. */
	char*           vidbuf;
	int             video_on=1;
	int             xfrsize;

   /*
	* INITIALIZE DEVICE AND HARDWARE LIBRARY.
	*/
	p_xv=pv700_open(device);
#ifdef IMAGE_DMA
	fd2=pv700_open("/dev/plxv1");
#endif /* IMAGE_DMA */
	O_PV700_vertical(p_xv, 1);
}
