
#include <stdio.h>
#include <fcntl.h>

#include "qtab.h"
#include "c3.h"
#include "xvideo.h"
#include "plxv_xpoint.h"
#include "plxv.h"

int fd1,fd2;


#ifndef SVR4
#define SVR4
#endif


main(argc,argv)
int argc;
char *argv[];
{
	int i,j,k, factor;
	int count1,count2,count;
	char s[10];
	static char defaultdev[12] = "/dev/plxv0";
	char *device = defaultdev;
	int *bptr;
	int *b2ptr;
	char *cbuf;
	int nwords=16;
	int width = 320;
	int heigth = 240;
	int xfrsize;
	int rcount;
	int loop=100;
	int dump=0;
	int stop=0;
	int first_time=1;
	u_int first_word;
	int flip=0;
	int outflip=0;
	u_int last_word;
	unsigned char *dmabuf;


	factor = 50;

	for(i = 1; i < argc; ++i)
	{
	    if(*argv[i] == '-')
	    {
		
		if(*(argv[i]+1) == 'f')
			device= argv[++i];
		else
		    if(*(argv[i]+1) == 't')
			loop= atoi(argv[++i]);
		else
		    goto use;
	    }
	    else
	    {
use:		printf("usage: %s, [-q #]\n", argv[0]);
		exit(1);
	    }
	}

       /*
        * Initialize
        */

	fd1=pv700_open(device);
	fd2=pv700_open("/dev/plxv1");
	XV_WREG(HNSyncS.l, 0x8000);	
	XV_WREG(HSyncS.l, 0x123);	

        plxv_tag(PLXV_TAG_PIXEL_ATTR,PLXV_TAG_TRUE_COLOR|1);	
        plxv_video_v_stencil(0,0);
        plxv_stencil(0,0);
        plxv_video_w_stencil(0,0);
        plxv_video_w_wmask(~0);
        plxv_video_v_wmask(~0);
        plxv_color_24(0xff0000);
	plxv_box(0,0,1280,1024);

	 xfrsize= width*heigth*4;
	dmabuf= (u_char *)malloc(xfrsize);

	Flash();
	while (loop--)
	{
	    plxv_dma_setup(0,0,320,240);
	    read(fd2,dmabuf,xfrsize);
	    plxv_dma_setup(100,240,320,240);
	    write(fd2,dmabuf,xfrsize);
	}
	free(dmabuf);
}

Flash()
{
	unsigned int daddr,vaddr;
	unsigned int vflag;
	int i,j;

 	plxv_xpoint_v(INPUT_D,1); 

    	plxv_flash_v_squeeze(0,24,640,480,0,0,320,240,0,0);

	/* this loop can be tweaked 
	 for (i=0;i<2;i++) for (j=0;j<32000;j++);
	 */
}

