#include "xvideo.h"
#include "plxv_xpoint.h"
#include "plxv.h"

main(argc,argv)
int argc;
char *argv[];
{

    int pattern;

    xv_cp =pv700_open(0);

    plxv_flash_v_off(); 
    plxv_flash_w_off();

    if (argc > 1) sscanf(argv[1],"%d",&pattern);
    switch (pattern)
    {
	case 1: draw1();
	    break;
	case 2: draw2();
	    break;
	case 3: draw3();
	    break;
	case 4: draw4();
	    break;
	case 5: draw5();
	    break;
	case 6: draw6();
	    break;
	default: draw1();
    }
}

draw1()
{
    int i,k,j,l;
    char *ip;

    plxv_mode_24();
    plxv_color_24(0xff00);
    plxv_box(0,0,xv_cp->main.xsize,xv_cp->main.ysize);
    plxv_wmask(PLXV_WMASK_ALL);
	for (j=7;j>-1;j--)
	{
	    k = (((j & 2) != 0) * 0xc0) | (((j & 4) != 0) * 0xc000) | 
		(((j & 1) != 0) * 0xc00000);
	    plxv_color_24(k);
	    plxv_box((7 - j) * 80,0,80,80);
	}
	for (j=7;j>-1;j--)
	{
	    k = j * 255 / 7;
	    l = k | (k << 8) | (k << 16);
	    plxv_color_24(l);
	    plxv_box((7 - j) * 80,80,80,80);
	}
	for (j=0; j<640; j++)
	{
	    k = (((j >> (j/80)) & 1)) * 0xff;
	    l = k | (k << 8) | (k << 16);
	    plxv_color_24(l);
	    plxv_box(j,160,1,80);
	}
	for (j=0; j<640; j++)
	{
	    k = (j * 0xff )/640;
 	    l = k;
	    plxv_color_24(l);
	    plxv_box(j,240,1,80);
	}
	for (j=0; j<640; j++)
	{
	    k = (j * 0xff )/640;
 	    l = k << 8;
	    plxv_color_24(l);
	    plxv_box(j,320,1,80);
	}
	for (j=0; j<640; j++)
	{
	    k = (j * 0xff )/640;
 	    l = k << 16;
	    plxv_color_24(l);
	    plxv_box(j,400,1,80);
	}

    plxv_color_24(0xffffff);
    plxv_vector(0,0,480,480);
    plxv_vector(0,0,640,0);
    plxv_vector(0,0,0,480);
    plxv_vector(0,479,640,0);
    plxv_vector(639,0,0,480);
    plxv_xpoint_w(OUTPUT_A,1);
    plxv_output_w(0,0,640,480,0,40,640,480,0,0); 
}

draw2()
{
    int i,k,j,l;
    char *ip;

    plxv_mode_8();
    plxv_color_8(0x18);
    plxv_box(0,0,xv_cp->main.xsize,xv_cp->main.ysize);
    plxv_mode_24();
    plxv_wmask(PLXV_WMASK_PIXEL_ATTR | 0xff);
    for (i=0;i<256;i++)
    {
	plxv_color_24(i);
	plxv_box(0,xv_cp->main.ysize-i-1,255,1);
    }
    plxv_wmask(PLXV_WMASK_PIXEL_ATTR | 0xff00);
    for (i=0;i<256;i++)
    {
	plxv_color_24(i<<8);
	plxv_box(i,xv_cp->main.ysize-255,1,254);
    }
    plxv_wmask(PLXV_WMASK_PIXEL_ATTR | 0xff0000);
    for (i=0;i<250;i++)
    {
	plxv_color_24(i<<16);
	plxv_box(1,xv_cp->main.ysize - 1,256-i,-256+i);
    }
    plxv_mode_8();
    k = xv_cp->main.ysize-256-100;
    for (j=0;j<100;j++)
    {
	ip = PLXV_ADDR_8(0,k++);
    	for (i=0;i<256;i++) *ip++ = (char)i;
    }
    for (i=0;i<256;i++)
    {
	plxv_color_8(i);
        plxv_box(256,xv_cp->main.ysize-i-1,100,1);
    }
    plxv_xpoint_w(OUTPUT_A,1);
    plxv_output_w(0,xv_cp->main.ysize - 480,640,480,0,40,640,480,0,0); 
}

draw3()
{
    int i,k,j,l;
    char *ip;

    plxv_mode_8();
    plxv_color_8(0x18);
    plxv_box(0,0,xv_cp->main.xsize,xv_cp->main.ysize);
    k = xv_cp->main.ysize - 480;
    for (j=0;j<480;j++)
    {
	ip = PLXV_ADDR_8(0,k++);
    	for (i=0;i<640;i++) *ip++ = (char)i;
    }
    plxv_xpoint_w(OUTPUT_A,1);
    plxv_output_w(0,xv_cp->main.ysize - 480,640,480,0,40,640,480,0,0); 
}

draw4()
{
    int i,k,j,l;
    char *ip;

    plxv_mode_24();
    plxv_color_24(0xff00);
    plxv_box(0,0,xv_cp->main.xsize,xv_cp->main.ysize);
    for (j=7;j>-1;j--)
    {
	k = (((j & 2) != 0) * 0xc0) | (((j & 4) != 0) * 0xc000) | 
		(((j & 1) != 0) * 0xc00000);
	plxv_color_24(k);
	plxv_box((7 - j) * 80,0,80,480);
    }
    plxv_xpoint_w(OUTPUT_A,1);
    plxv_output_w(0,0,640,480,0,40,640,480,0,0); 
}

draw5()
{
    int i,k,j,l;
    int *ip;

    plxv_mode_8();
    plxv_color_8(0x18);
    plxv_box(0,0,xv_cp->main.xsize,xv_cp->main.ysize);

    plxv_mode_24();
    k = xv_cp->main.ysize-480;
    for (j=0;j<480;j++)
    {
	ip = PLXV_ADDR_24(0,k++);
    	for (i=0;i<640;i++) *ip++ = i | (i << 8) | (i << 16);
    }

    plxv_xpoint_w(OUTPUT_A,1);
    plxv_output_w(0,xv_cp->main.ysize - 480,640,480,0,40,640,480,0,0); 
}

draw6()
{
    int i,k,j,l;
    int *ip;

    plxv_mode_24();
    plxv_color_24(0xff);
    plxv_box(0,0,xv_cp->main.xsize,xv_cp->main.ysize);

    plxv_xpoint_w(OUTPUT_A,1);
    plxv_output_w(0,xv_cp->main.ysize - 480 - 10,640,480,0,40,640,480,0,0); 
}
