/*
 *  Test that we can open a device name.
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <sys/types.h>
#include "objects_internal.h"
#include "video_stream.h"
#include "hw_context.h"

main(argc, argv)
	int		argc;
	char	*argv[];
{
	int	fd;	/* File descriptor for device opened. */
	int	page_size;
	char*		rsrc_file;		/* Resource file to use. */
	XV_struct*	p_me;			/* Hardware access object. */

	if ( argc != 2 )
	{
		fprintf(stderr, "Usage: open device\n");
	}

	fd = open(argv[1], O_RDWR);

	if ( fd == -1 )
	{
		fprintf(stdout, "Unable to open %s\n", argv[1]);
	}
	else
	{
		fprintf(stdout, "Opened %s with file descriptor %d\n", argv[1], fd);
	}
	page_size = getpagesize();
	rsrc_file = (char*)O_HWL_rsrc();
	p_me = O_HWL_O_HWL("full", O_HWL_device(), rsrc_file);
}
