#include "stdio.h"
#include "xvideo.h"
#include "plxv.h"
#include "plxv_xpoint.h"

main(argc,argv)
int argc;
char *argv[];
{
    int i,k,j,l,mode;
        int fd;
    int opt_board;
    char junk[132];
    char *ip;
        XV_struct*      p_xv;

    p_xv=pv700_open("/dev/plxv0");
#ifdef mips
    plxv_28_now(p_xv, 0);
#else
    plxv_28_now(p_xv, 0);
#endif
        mode = 0;
        if (argc>3) {
                int i,j;
                sscanf(argv[1],"%x",&i);
                sscanf(argv[2],"%x",&j);
                sscanf(argv[3],"%x",&mode);
        }
        else if (argc>1) {
                sscanf(argv[1],"%x",&mode);
        }

        plxv_mode_24(p_xv);
    plxv_tag(p_xv, PLXV_TAG_PIXEL_ATTR,PLXV_TAG_TRUE_COLOR|0x01);       
    plxv_video_v_stencil(p_xv, 0,0);
    plxv_stencil(p_xv, 0,0);
    plxv_video_w_stencil(p_xv, 0,0);
    plxv_video_w_wmask(p_xv, ~0);
    plxv_video_v_wmask(p_xv, ~0);
    plxv_color_24(p_xv, 0xff0000);
        plxv_box(p_xv, 0,0,1280,1024);

    /* draw a colorful box... r then g, then b */
    plxv_mode_24(p_xv);
    plxv_wmask(p_xv, PLXV_WMASK_PIXEL_ATTR | 0xff);
    for (i=0;i<256;i++)
    {
        plxv_color_24(p_xv, i);
        plxv_box(p_xv, 0,p_xv->main.ysize-i-1,255,1);
    }

    plxv_wmask(p_xv, PLXV_WMASK_PIXEL_ATTR | 0xff00);
    for (i=0;i<256;i++)
    {
        plxv_color_24(p_xv, i<<8);
        plxv_box(p_xv, i,p_xv->main.ysize-255,1,254);
    }
    plxv_wmask(p_xv, PLXV_WMASK_PIXEL_ATTR | 0xff0000);

    for (i=0;i<250;i++)
    {
        plxv_color_24(p_xv, i<<16);
        plxv_box(p_xv, i, 0, 1, p_xv->main.ysize - 1);
    }

#ifdef TEST
    /* draw a pseudo color scale in MAP mode */
    plxv_mode_8(p_xv);
    k = p_xv->main.ysize-256-100;
    for (j=0;j<100;j++)
    {
        ip = PLXV_ADDR_8(p_xv, 0,k++);
        for (i=0;i<256;i++) *ip++ = (char)i;
    }

    /* draw a pseudo color scale in ACCEL mode */
    for (i=0;i<256;i++)
    {
        plxv_color_8(p_xv, i);
        plxv_box(p_xv, 256,p_xv->main.ysize-i-1,100,1);
    }
#endif

printf("1?"); fgetc(stdin);
    /* draw WINDOWS of video TAG */
    plxv_stencil(p_xv, 0,0);
    plxv_wmask(p_xv, -1);
    plxv_color_24(p_xv, 0x000000ff); 
    plxv_tag(p_xv, PLXV_TAG_ALL,((PLXV_TAG_VIDEO_0)>>4) |1);
    plxv_box(p_xv, 10,10,640,483);
    plxv_color_24(p_xv, 0x0000ff00); 
    plxv_tag(p_xv, PLXV_TAG_ALL,((PLXV_TAG_VIDEO_0+1)>>4) |1);
    plxv_box(p_xv, 640,480,640,483);

    /* startup flash on V*/
#ifdef NOTDEF
    plxv_video_v_stencil(p_xv, 0xe,PLXV_TAG_VIDEO_0>>4);
#endif NOTDEF
printf("2?"); fgetc(stdin);
    plxv_video_v_wmask(p_xv, PLXV_WMASK_24);
    if (mode>1) { plxv_flash_v_squeeze(p_xv, 40,42,640,480,10,10,320,240,0,0);
        } else plxv_flash_v_squeeze(p_xv, 0,42,640,480,10,10,640,480,0,0);
printf("3?"); fgetc(stdin);

    /* startup flash on W */
    /* check if option card is installed */
    if (opt_board =p_xv->opt.board_code)
    {
        switch(opt_board)
        {
          case 14:
          case 10:      /* NTSC/PAL option card */
            plxv_xpoint_w(p_xv, INPUT_B,1); 
            break;
          case 11:      /* RGB/YUV option card */
            plxv_xpoint_w(p_xv, INPUT_A,1); 
            break;
          default:
            printf("demo: don't know that option board code yet\n");
            plxv_xpoint_w(p_xv, INPUT_D,1); 
            break;
        }
    }
    else    plxv_xpoint_w(p_xv, INPUT_D,1); 

printf("4?"); fgetc(stdin);
    plxv_video_w_stencil(p_xv, 0x0e,PLXV_TAG_VIDEO_0>>4);
    plxv_video_w_wmask(p_xv, PLXV_WMASK_24);
    if (mode<1) plxv_flash_w_squeeze(p_xv, 0,42,640,480,640,480,640,480,0,0);
        if (mode>2) plxv_flash_w_squeeze(p_xv, 40,42,640,480,450,380,320,240,0,0);
printf("5?"); fgetc(stdin);

/*
    while(1)
    {
        int i,j;
        float a,b;
        i = plxv_read_timer(p_xv);
        plxv_load_input_clt(p_xv, 3,0,0,1);
        j = plxv_read_timer(p_xv);
        j -= i;
        printf("time to load 7192 = %f\n",(float)(j/90000.0));
    }
*/
    plxv_mode_8(p_xv);
}
